﻿using Infragistics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExcelExport
{
    public class Employee : PropertyChangeNotifier
    {
        private string _name;
        private string _dept;
        private decimal _salary;
        private string _company;
        //private int _age;
        private DateTime _birthDate;

        public Employee()
        {
        }

        public Employee(string name, string dept, decimal salary, string comp = "", DateTime? birth = null)
        {
            _name = name;
            _dept = dept;
            _company = comp;
            _salary = salary;
            _birthDate = birth.HasValue ? birth.Value : DateTime.MinValue;
        }

        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                this.RaisePropertyChangedEvent("Name");
            }
        }

        public string Department
        {
            get { return _dept; }
            set
            {
                _dept = value;
                this.RaisePropertyChangedEvent("Department");
            }
        }

        public decimal Salary
        {
            get { return _salary; }
            set
            {
                _salary = value;
                this.RaisePropertyChangedEvent("Salary");
            }
        }

        public string Company
        {
            get { return _company; }
            set
            {
                if (_company != value)
                {
                    _company = value;
                    this.RaisePropertyChangedEvent("Company");
                }
            }
        }

        public int Age
        {
            get
            { return DateTime.Now.Year - BirthDate.Year; }
        }

        public DateTime BirthDate
        {
            get
            { return _birthDate; }
            set
            {
                if (_birthDate != value)
                {
                    _birthDate = value;
                    this.RaisePropertyChangedEvent("BirthDate");
                    this.RaisePropertyChangedEvent("Age");
                }
            }
        }
    }

    public class EmployeeEx : PropertyChangeNotifier
    {
        private string _name;
        private string _dept;
        private decimal _salary;
        private int _svalue1;

        private int _svalue2;
        private int _svalue3;
        private int _svalue4;
        private int _svalue5;
        private int _svalue6;
        private int _svalue7;
        private int _svalue8;
        private int _svalue9;
        private int _svalue10;
        private int _svalue11;
        private int _svalue12;
        private int _svalue13;
        private int _svalue14;
        private int _svalue15;
        private int _svalue16;
        private int _svalue17;
        private int _svalue18;
        private int _svalue19;
        private int _svalue20;
        private int _svalue21;
        private int _svalue22;
        private int _svalue23;
        private int _svalue24;
        private int _svalue25;
        private int _svalue26;
        private int _svalue27;
        private int _svalue28;
        private int _svalue29;
        private int _svalue30;


        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                this.RaisePropertyChangedEvent("Name");
            }
        }

        public string Department
        {
            get { return _dept; }
            set
            {
                _dept = value;
                this.RaisePropertyChangedEvent("Department");
            }
        }

        public decimal Salary
        {
            get { return _salary; }
            set
            {
                _salary = value;
                this.RaisePropertyChangedEvent("Salary");
            }
        }

        public int Svalue1 { get { return _svalue1; } set { _svalue1 = value; this.RaisePropertyChangedEvent("Svalue1"); } }
        public int Svalue2 { get { return _svalue2; } set { _svalue2 = value; this.RaisePropertyChangedEvent("Svalue2"); } }
        public int Svalue3 { get { return _svalue3; } set { _svalue3 = value; this.RaisePropertyChangedEvent("Svalue3"); } }
        public int Svalue4 { get { return _svalue4; } set { _svalue4 = value; this.RaisePropertyChangedEvent("Svalue4"); } }
        public int Svalue5 { get { return _svalue5; } set { _svalue5 = value; this.RaisePropertyChangedEvent("Svalue5"); } }
        public int Svalue6 { get { return _svalue6; } set { _svalue6 = value; this.RaisePropertyChangedEvent("Svalue6"); } }
        public int Svalue7 { get { return _svalue7; } set { _svalue7 = value; this.RaisePropertyChangedEvent("Svalue7"); } }
        public int Svalue8 { get { return _svalue8; } set { _svalue8 = value; this.RaisePropertyChangedEvent("Svalue8"); } }
        public int Svalue9 { get { return _svalue9; } set { _svalue9 = value; this.RaisePropertyChangedEvent("Svalue9"); } }
        public int Svalue10 { get { return _svalue10; } set { _svalue10 = value; this.RaisePropertyChangedEvent("Svalue10"); } }
        public int Svalue11 { get { return _svalue11; } set { _svalue11 = value; this.RaisePropertyChangedEvent("Svalue11"); } }
        public int Svalue12 { get { return _svalue12; } set { _svalue12 = value; this.RaisePropertyChangedEvent("Svalue12"); } }
        public int Svalue13 { get { return _svalue13; } set { _svalue13 = value; this.RaisePropertyChangedEvent("Svalue13"); } }
        public int Svalue14 { get { return _svalue14; } set { _svalue14 = value; this.RaisePropertyChangedEvent("Svalue14"); } }
        public int Svalue15 { get { return _svalue15; } set { _svalue15 = value; this.RaisePropertyChangedEvent("Svalue15"); } }
        public int Svalue16 { get { return _svalue16; } set { _svalue16 = value; this.RaisePropertyChangedEvent("Svalue16"); } }
        public int Svalue17 { get { return _svalue17; } set { _svalue17 = value; this.RaisePropertyChangedEvent("Svalue17"); } }
        public int Svalue18 { get { return _svalue18; } set { _svalue18 = value; this.RaisePropertyChangedEvent("Svalue18"); } }
        public int Svalue19 { get { return _svalue19; } set { _svalue19 = value; this.RaisePropertyChangedEvent("Svalue19"); } }
        public int Svalue20 { get { return _svalue20; } set { _svalue20 = value; this.RaisePropertyChangedEvent("Svalue20"); } }
        public int Svalue21 { get { return _svalue21; } set { _svalue21 = value; this.RaisePropertyChangedEvent("Svalue21"); } }
        public int Svalue22 { get { return _svalue22; } set { _svalue22 = value; this.RaisePropertyChangedEvent("Svalue22"); } }
        public int Svalue23 { get { return _svalue23; } set { _svalue23 = value; this.RaisePropertyChangedEvent("Svalue23"); } }
        public int Svalue24 { get { return _svalue24; } set { _svalue24 = value; this.RaisePropertyChangedEvent("Svalue24"); } }
        public int Svalue25 { get { return _svalue25; } set { _svalue25 = value; this.RaisePropertyChangedEvent("Svalue25"); } }
        public int Svalue26 { get { return _svalue26; } set { _svalue26 = value; this.RaisePropertyChangedEvent("Svalue26"); } }
        public int Svalue27 { get { return _svalue27; } set { _svalue27 = value; this.RaisePropertyChangedEvent("Svalue27"); } }
        public int Svalue28 { get { return _svalue28; } set { _svalue28 = value; this.RaisePropertyChangedEvent("Svalue28"); } }
        public int Svalue29 { get { return _svalue29; } set { _svalue29 = value; this.RaisePropertyChangedEvent("Svalue29"); } }
        public int Svalue30 { get { return _svalue30; } set { _svalue30 = value; this.RaisePropertyChangedEvent("Svalue30"); } }

    }
}