﻿using Infragistics.Documents.Excel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ExcelExport
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            var dataSource = (from d in Enumerable.Range(0, 10000)
                              select new Employee
                              {
                                  Company = RandomizeUtility.GenerateRandomString(12, false),
                                  Department = RandomizeUtility.GenerateRandomString(12, true),
                                  Name = RandomizeUtility.GenerateRandomString(12, false),
                                  BirthDate = RandomizeUtility.GenerateRandomDate(new DateTime(1940, 1, 1)),
                                  Salary = Math.Round((decimal)RandomizeUtility.GenerateRandomDouble(1000, 20000), 2)
                              });

            ObservableCollection<Employee> data = new ObservableCollection<Employee>(dataSource);

            XDG.DataSource = data;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = LayoutRoot.Resources["exporter"] as DataPresenterExcelExporter;
            exporter.ExportAsync(XDG, "Export.xlsx", WorkbookFormat.Excel2007);
            exporter.ExportEnded += exporter_ExportEnded;
        }

        void exporter_ExportEnded(object sender, ExportEndedEventArgs e)
        {


            DataPresenterExcelExporter exporter = LayoutRoot.Resources["exporter"] as DataPresenterExcelExporter;
            exporter.ExportEnded -= exporter_ExportEnded;

            for (int i = 0; i < 20000; i++)
            {
                int y = 1 + i;
            }
            if (e.Canceled)
            {
                if (e.CancelInfo.Reason == RecordExportCancellationReason.Exception)
                    MessageBox.Show(e.CancelInfo.Exception.Message, "An exception occured during the Export operation");

            }
            else
            {
                Process.Start("Export.xlsx");
            }
        }
    }
}
